#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLMULTTRANSPOSEMATRIXDPROC glMultTransposeMatrixd;
PFNGLGENFRAMEBUFFERSEXTPROC glGenFramebuffersEXT;
PFNGLBINDFRAMEBUFFEREXTPROC glBindFramebufferEXT;
PFNGLFRAMEBUFFERTEXTURE2DEXTPROC glFramebufferTexture2DEXT;
PFNGLGENRENDERBUFFERSEXTPROC glGenRenderbuffersEXT;
PFNGLBINDRENDERBUFFEREXTPROC glBindRenderbufferEXT;
PFNGLRENDERBUFFERSTORAGEEXTPROC glRenderbufferStorageEXT;
PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC glFramebufferRenderbufferEXT;
PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC glCheckFramebufferStatusEXT;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif
#include "glsl.h"

#define CHECK_FRAMEBUFFER_STATUS() \
{ \
  GLenum status; \
  status = glCheckFramebufferStatusEXT(GL_FRAMEBUFFER_EXT); \
  switch(status) { \
  case GL_FRAMEBUFFER_COMPLETE_EXT: \
    break; \
  case GL_FRAMEBUFFER_UNSUPPORTED_EXT: \
    fprintf(stderr, "choose different formats\n"); \
    break; \
  default: \
    fprintf(stderr, "programming error; will fail on all hardware: %04x\n", status); \
  } \
}

/*
** ֥
*/
static GLuint vertShader;
static GLuint fragShader;
static GLuint gl2Program;

/*
** 
*/
static const GLfloat lightpos[] = { 4.0, 9.0, 5.0, 1.0 }; /* ֡ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ľܸ١ */
static const GLfloat lightdim[] = { 0.2, 0.2, 0.2, 1.0 }; /* γȻȿͶ */
static const GLfloat lightblk[] = { 0.0, 0.0, 0.0, 1.0 }; /* ζȿͶ */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* Ķ١ */

/*
** ƥ
*/
#define TEXWIDTH  1024                                    /* ƥ */
#define TEXHEIGHT 1024                                    /* ƥι⤵ */

/*
** ƥ㥪֥ȡե졼Хåե֥
*/
static GLuint tex, fb, rb;

/*
** 
*/
static void init(void)
{
  /* ץΥѥ롿󥯷̤ѿ */
  GLint compiled, linked;
  
#if defined(WIN32)
  glGenFramebuffersEXT =
    (PFNGLGENFRAMEBUFFERSEXTPROC)wglGetProcAddress("glGenFramebuffersEXT");
  glBindFramebufferEXT =
    (PFNGLBINDFRAMEBUFFEREXTPROC)wglGetProcAddress("glBindFramebufferEXT");
  glFramebufferTexture2DEXT =
    (PFNGLFRAMEBUFFERTEXTURE2DEXTPROC)wglGetProcAddress("glFramebufferTexture2DEXT");
  glGenRenderbuffersEXT =
    (PFNGLGENRENDERBUFFERSEXTPROC)wglGetProcAddress("glGenRenderbuffersEXT");
  glBindRenderbufferEXT =
    (PFNGLBINDRENDERBUFFEREXTPROC)wglGetProcAddress("glBindRenderbufferEXT");
  glRenderbufferStorageEXT =
    (PFNGLRENDERBUFFERSTORAGEEXTPROC)wglGetProcAddress("glRenderbufferStorageEXT");
  glFramebufferRenderbufferEXT =
    (PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC)wglGetProcAddress("glFramebufferRenderbufferEXT");
  glCheckFramebufferStatusEXT =
    (PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC)wglGetProcAddress("glCheckFramebufferStatusEXT");
#endif
  
  /* ƥ㥪֥ȤƷ礹 */
  glGenTextures(1, &tex);
  glBindTexture(GL_TEXTURE_2D, tex);

  /* ƥγ */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, TEXWIDTH, TEXHEIGHT, 0,
    GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, 0);
  
  /* ƥ硦̾ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  
  /* ƥη֤ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  
  /* 񤭹ݥꥴΥƥɸͤΣҤȥƥȤӤԤ褦ˤ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE, GL_COMPARE_R_TO_TEXTURE);
  
  /* ⤷ҤͤƥͰʲʤ鿿ʤĤޤ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC, GL_LEQUAL);
  
  /* Ӥη̤ͤȤ */
  glTexParameteri(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_LUMINANCE);
  
#if 0
  /* ƥɸ˻ɸϤˤʪΤκɸͤѤ */
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_Q, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);

  /* ƥɸ򤽤Τޤ (S, T, R, Q) ˻Ȥ */
  static const GLdouble genfunc[][4] = {
    { 1.0, 0.0, 0.0, 0.0 },
    { 0.0, 1.0, 0.0, 0.0 },
    { 0.0, 0.0, 1.0, 0.0 },
    { 0.0, 0.0, 0.0, 1.0 },
  };
  glTexGendv(GL_S, GL_EYE_PLANE, genfunc[0]);
  glTexGendv(GL_T, GL_EYE_PLANE, genfunc[1]);
  glTexGendv(GL_R, GL_EYE_PLANE, genfunc[2]);
  glTexGendv(GL_Q, GL_EYE_PLANE, genfunc[3]);
#endif

  /* ƥ㥪֥Ȥη */
  glBindTexture(GL_TEXTURE_2D, 0);

  /* ե졼Хåե֥ȤƷ礹 */
  glGenFramebuffersEXT(1, &fb);
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);

  /* ե졼Хåե֥Ȥ˥ǥץХåեѤΥƥ礹 */
  glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT,
    GL_TEXTURE_2D, tex, 0);

  /* 顼Хåե̵Τɤ߽񤭤ʤ */
  glDrawBuffer(GL_NONE);
  glReadBuffer(GL_NONE);

  CHECK_FRAMEBUFFER_STATUS();

  /* ե졼Хåե֥Ȥη */
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);

  /*  */
  glClearColor(0.3, 0.3, 1.0, 1.0);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);
  
  /* ν */
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);

  /* GLSL ν */
  if (glslInit()) exit(1);
  
  /* ֥Ȥκ */
  vertShader = glCreateShader(GL_VERTEX_SHADER);
  fragShader = glCreateShader(GL_FRAGMENT_SHADER);
  
  /* Υץɤ߹ */
  if (readShaderSource(vertShader, "shadow.vert")) exit(1);
  if (readShaderSource(fragShader, "shadow.frag")) exit(1);
  
  /* СƥåΥץΥѥ */
  glCompileShader(vertShader);
  glGetShaderiv(vertShader, GL_COMPILE_STATUS, &compiled);
  printShaderInfoLog(vertShader);
  if (compiled == GL_FALSE) {
    fprintf(stderr, "Compile error in vertex shader.\n");
    exit(1);
  }
  
  /* ե饰ȥΥץΥѥ */
  glCompileShader(fragShader);
  glGetShaderiv(fragShader, GL_COMPILE_STATUS, &compiled);
  printShaderInfoLog(fragShader);
  if (compiled == GL_FALSE) {
    fprintf(stderr, "Compile error in fragment shader.\n");
    exit(1);
  }
  
  /* ץ४֥Ȥκ */
  gl2Program = glCreateProgram();
  
  /* ֥ȤΥץؤϿ */
  glAttachShader(gl2Program, vertShader);
  glAttachShader(gl2Program, fragShader);
  
  /* ֥Ȥκ */
  glDeleteShader(vertShader);
  glDeleteShader(fragShader);
  
  /* ץΥ */
  glLinkProgram(gl2Program);
  glGetProgramiv(gl2Program, GL_LINK_STATUS, &linked);
  printProgramInfoLog(gl2Program);
  if (linked == GL_FALSE) {
    fprintf(stderr, "Link error.\n");
    exit(1);
  }
  
  /* ץŬ */
  glUseProgram(gl2Program);

  /* ƥ˥åȣꤹ */
  glUniform1i(glGetUniformLocation(gl2Program, "texture"), 0);
  
#if defined(WIN32)
  glMultTransposeMatrixd =
    (PFNGLMULTTRANSPOSEMATRIXDPROC)wglGetProcAddress("glMultTransposeMatrixd");
#endif
}


/****************************
** GLUT ΥХåؿ **
****************************/

/* ȥåܡѴؿ */
#include "trackball.h"

/* ؿ */
#include "scene.h"

/* ˥᡼Υ */
#define FRAMES 600

static void display(void)
{
  GLint viewport[4];       /* ӥ塼ݡȤ¸ѡ */
  GLdouble modelview[16];  /* ǥӥ塼Ѵ¸ */
  GLdouble projection[16]; /* ƩѴ¸ѡ */
  static int frame = 0;    /* ե졼Υȡ */
  double t = (double)frame / (double)FRAMES; /* в֡ */

  if (++frame >= FRAMES) frame = 0;

  /*
  ** 裱ƥåסǥץƥκ
  */
  
  /* ե졼Хåե֥ȤؤΥ󥰳 */
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);

  /* ǥץХåե򥯥ꥢ */
  glClear(GL_DEPTH_BUFFER_BIT);
  
  /* ߤΥӥ塼ݡȤ¸Ƥ */
  glGetIntegerv(GL_VIEWPORT, viewport);
  
  /* ӥ塼ݡȤƥΥꤹ */
  glViewport(0, 0, TEXWIDTH, TEXHEIGHT);
  
  /* ߤƩѴ¸Ƥ */
  glGetDoublev(GL_PROJECTION_MATRIX, projection);
  
  /* ƩѴñ̹ꤹ */
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  
  /* ֤Ȥ󤬻˼ޤ褦ǥӥ塼Ѵꤹ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluPerspective(40.0, (GLdouble)TEXWIDTH / (GLdouble)TEXHEIGHT, 1.0, 20.0);
  gluLookAt(lightpos[0], lightpos[1], lightpos[2], 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

  /* ꤷǥӥ塼Ѵ¸Ƥ */
  glGetDoublev(GL_MODELVIEW_MATRIX, modelview);

  /* ǥץХåեƤΤǥե졼ХåեˤϽ񤭹ޤʤ */
  glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);

  /* äƱդפʤΤǥ饤ƥ󥰤򥪥դˤ */
  glDisable(GL_LIGHTING);

  /* ǥץХåեˤ̤ΥݥꥴαԤϿ褦ˤ */
  glCullFace(GL_FRONT);

  /* 褹 */
  scene(t);

  /* ե졼Хåե֥ȤؤΥ󥰽λ */
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);

#if 0
  /* ǥץХåեƤƥž */
  glCopyTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 0, 0, TEXWIDTH, TEXHEIGHT);
#endif

  /* ᤹̾ */
  glViewport(viewport[0], viewport[1], viewport[2], viewport[3]);
  glMatrixMode(GL_PROJECTION);
  glLoadMatrixd(projection);
  glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
  glEnable(GL_LIGHTING);
  glCullFace(GL_BACK);
  
  /*
  ** 裲ƥåסΤ
  */
  
  /* ե졼ХåեȥǥץХåե򥯥ꥢ */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* ǥӥ塼Ѵ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ΰ֤ꤹʪΤ˰ư*/
  glTranslated(0.0, 0.0, -10.0);
  
  /* ȥåܡ뼰βžͿ */
  glMultMatrixd(trackballRotation());
  
  /* ΰ֤ꤹ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* ƥѴꤹ */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  
  /* ƥɸ [-1,1] ϰϤ [0,1] ϰϤ˼ */
  glTranslated(0.5, 0.5, 0.5);
  glScaled(0.5, 0.5, 0.5);
  
  /* ƥΥǥӥ塼ѴƩѴѤ򤫤 */
  glMultMatrixd(modelview);
  
  /* ߤΥǥӥ塼ѴεѴ򤫤Ƥ */
  glMultTransposeMatrixd(trackballRotation());
  glTranslated(0.0, 0.0, 10.0);
  
  /* ǥӥ塼Ѵ᤹ */
  glMatrixMode(GL_MODELVIEW);
  
  /* ƥ㥪֥Ȥ礹 */
  glBindTexture(GL_TEXTURE_2D, tex);

  /* ƥޥåԥ󥰤ȥƥɸμưͭˤ */
  glEnable(GL_TEXTURE_2D);
#if 0
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);
  glEnable(GL_TEXTURE_GEN_Q);
#endif
  
  /* 뤵ʬǤ뤵 */
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);
  
  /* 褹 */
  scene(t);
  
  /* ƥޥåԥ󥰤ȥƥɸμư̵ˤ */
#if 0
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  glDisable(GL_TEXTURE_GEN_Q);
#endif
  glDisable(GL_TEXTURE_2D);
  
  /* ƥ㥪֥Ȥη */
  glBindTexture(GL_TEXTURE_2D, 0);
  
  /* ֥Хåե */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
#if 0
  /* ɥν̾¤ */
  if (w < TEXWIDTH || h < TEXHEIGHT) {
    if (w < TEXWIDTH) w = TEXWIDTH;
    if (h < TEXHEIGHT) h = TEXHEIGHT;
    glutReshapeWindow(w, h);
  }
#endif

  /* ȥåܡ뤹ϰ */
  trackballRegion(w, h);
  
  /* ɥΤӥ塼ݡȤˤ */
  glViewport(0, 0, w, h);
  
  /* ƩѴλ */
  glMatrixMode(GL_PROJECTION);
  
  /* ƩѴν */
  glLoadIdentity();
  gluPerspective(40.0, (double)w / (double)h, 1.0, 100.0);
}

static void idle(void)
{
  /* ̤ؤ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* ȥåܡ볫 */
      trackballStart(x, y);
      break;
    case GLUT_UP:
      /* ȥåܡ */
      trackballStop(x, y);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* ȥåܡư */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q 򥿥פ齪λ */
    exit(0);
  default:
    break;
  }
}

/*
** ᥤץ
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
#if 0
  glutInitWindowSize(TEXWIDTH, TEXHEIGHT);
#endif
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  glutIdleFunc(idle);
  init();
  glutMainLoop();
  return 0;
}
